unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Printers;

type
  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private declarations }
   function DefaultPrinter(APrinter: TPrinter): string;
  public
    { Public declarations }
   FPrinter: TPrinter;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ TForm1 }

function TForm1.DefaultPrinter(APrinter: TPrinter): string;
begin
 APrinter.PrinterIndex := -1;
 Result := APrinter.Printers[APrinter.PrinterIndex];
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 FPrinter := Printer;
 Combobox1.Items.Assign(FPrinter.Printers);
 Combobox1.Text := Defaultprinter(FPrinter);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 Combobox1.Text := Defaultprinter(FPrinter);
end;

procedure TForm1.Button2Click(Sender: TObject);
var TextWidth: Integer;
    TextHeight: Integer;
    X,Y: Integer;
begin
 TextWidth := FPrinter.Canvas.TextWidth(FPrinter.Printers[Fprinter.PrinterIndex]);
 TextHeight := FPrinter.Canvas.TextHeight(FPrinter.Printers[Fprinter.PrinterIndex]);
 X := (FPrinter.PageWidth - TextWidth) div 2;
 Y := (Fprinter.PageHeight - TextHeight) div 2;
 FPrinter.BeginDoc;
try
 FPrinter.Canvas.TextOut(X,Y,FPrinter.Printers[Fprinter.PrinterIndex]);
 FPrinter.EndDoc;
except
 FPrinter.Abort;
end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
 FPrinter.PrinterIndex := Combobox1.ItemIndex;
end;

end.
